function value = readsensor(sensornumber, cmd)

persistent ptr handle;

if(nargin<2)
    cmd = 'read';
end

value = 0;

if(strcmp(cmd,'init')==1)
    loadlibrary phidget20 phidget20.h alias plib;
%     loadlibrary('phidget20','phidget20.h', 'alias','plib');    
    ptr = libpointer('int32Ptr',0);
    
    open = calllib('plib', 'CPhidgetInterfaceKit_create', ptr);
    handle = get(ptr, 'Value');

    open = calllib('plib', 'CPhidget_open', handle, -1);
    
    % make sure it opened
    if open == 0
%         disp('Opened interface kit')
    else
        disp('Couldn''t open interface kit');
        unloadlibrary('plib');
        return;
    end
    return;
        
end

% clean up
if(strcmp(cmd,'exit')==1)
    calllib('plib', 'CPhidget_close', handle);
%     unloadlibrary('plib');
    unloadlibrary plib;
    return;
end

dataptr = libpointer('int32Ptr',0);
calllib('plib', 'CPhidgetInterfaceKit_read', handle);
calllib('plib', 'CPhidgetInterfaceKit_read', handle);

value = zeros(size(sensornumber));

%get the value, make sure it's valid
for i=1:numel(sensornumber)
    
    if calllib('plib', 'CPhidgetInterfaceKit_getSensorValue', handle, sensornumber(i), dataptr) == 0
        value(i) = get(dataptr, 'Value');
    else
        error('failed to read value');
    end

end